'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactColorsPicker = require('react-colors-picker');

var _reactColorsPicker2 = _interopRequireDefault(_reactColorsPicker);

var _d = require('d3');

var _d2 = _interopRequireDefault(_d);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HandlerWidth = 4;
var ColorPickerWidth = 16;
var Width = 300;
var Height = 15;
var ColorMode = 'rgb';
var DefaultStops = [{ offset: 0.0, color: '#00f' }, { offset: 0.5, color: '#aaa' }, { offset: 1.0, color: '#f00' }];

var CompareOffset = function CompareOffset(a, b) {
  return a.offset - b.offset;
};

var ReactGradientColorPicker = (function (_React$Component) {
  _inherits(ReactGradientColorPicker, _React$Component);

  function ReactGradientColorPicker(props) {
    _classCallCheck(this, ReactGradientColorPicker);

    // TODO: how to get auto-expanded width

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactGradientColorPicker).call(this, props));

    var rootHeight = Height;
    var rootWidth = Width;

    // init canvas instance
    _this.svg = null;

    // receive stops from props
    var defaultStops = _this.props.stops || DefaultStops;

    // populate color stop data
    var stops = defaultStops.map(function iterator(d, idx) {
      return {
        idx: idx,
        x: rootWidth * d.offset,
        offset: d.offset,
        color: d.color
      };
    });

    // init state
    _this.state = {
      rootWidth: rootWidth,
      rootHeight: rootHeight,
      colorModel: ColorMode,
      stops: stops
    };
    return _this;
  }

  _createClass(ReactGradientColorPicker, [{
    key: 'addHandler',
    value: function addHandler(mouseX) {
      var offset = 1.0 * mouseX / this.state.rootWidth;
      var midColor = this.colorScale(offset);
      var newStop = {
        idx: this.state.stops.length,
        x: mouseX,
        offset: offset,
        color: midColor
      };
      var newStops = this.state.stops.concat([newStop]);
      newStops.sort(CompareOffset);
      this.setState({ stops: newStops });

      // notify change
      this.props.onChange(this.colorScale);
    }
  }, {
    key: 'dragHandler',
    value: function dragHandler(d, mouseX) {
      // only update handler position but not state
      d.x = mouseX;
      _d2.default.select(this).attr('x', mouseX);
      _d2.default.select('#gc-cp' + d.idx).style('left', d.x - ColorPickerWidth / 2 + 'px').style('top', Height + 'px');
    }
  }, {
    key: 'dragHandlerEnd',
    value: function dragHandlerEnd(d) {
      // when the end of drag, update the state once.
      var newStops = _lodash2.default.cloneDeep(this.state.stops);
      var currentHandler = _lodash2.default.find(newStops, { 'idx': d.idx });
      currentHandler.offset = 1.0 * d.x / this.state.rootWidth;
      currentHandler.x = d.x;
      this.setState({ stops: newStops });

      // notify change
      this.props.onChange(this.colorScale);
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      // try to get the auto-expanded comonent width
      var rootWidth = this.refs.root.offsetWidth;
      var newStops = _lodash2.default.cloneDeep(this.state.stops);
      newStops.forEach(function iterator(d) {
        d.x = d.offset * rootWidth;
      });
      // TODO: this is anti-pattern. should fix it soon.
      this.setState({
        rootWidth: rootWidth,
        stops: newStops
      });

      var self = this;
      var clickColorMap = function clickColorMap() {
        var mouseX = _d2.default.mouse(this)[0];
        self.addHandler(mouseX);
      };

      // init canvas
      this.svg = _d2.default.select('#gc-canvas').append('svg').attr('width', this.state.rootWidth).attr('height', this.state.rootHeight);

      this.gradient = this.svg.append('linearGradient').attr('id', 'gc-gradient').attr('gradientUnits', 'userSpaceOnUse').attr('y1', '0').attr('y2', '0').attr('x1', '0').attr('x2', this.state.rootWidth);

      this.colorMap = this.svg.append('rect').attr('id', 'gc-color-map').attr('x', 0).attr('y', 0).attr('width', this.state.rootWidth).attr('height', this.state.rootHeight).attr('fill', 'url(#gc-gradient)').on('click', clickColorMap);
    }
  }, {
    key: 'refreshCanvas',
    value: function refreshCanvas() {
      if (this.svg === null) {
        return;
      }

      // refresh canvas size
      this.svg.attr('width', this.state.rootWidth).attr('height', this.state.rootHeight);

      this.colorMap.attr('width', this.state.rootWidth).attr('height', this.state.rootHeight);

      // refresh gradient
      this.gradient = this.svg.select('#gc-gradient').attr('x2', this.state.rootWidth).selectAll('stop').data(this.state.stops);

      // enter stops
      this.gradient.enter().append('stop').attr('offset', function offsetAccessor(d) {
        return d.offset * 100 + '%';
      }).attr('stop-color', function colorAccessor(d) {
        return d.color;
      });
      // update existing stops
      this.gradient.attr('offset', function offsetAccessor(d) {
        return (d.offset * 100).toString() + '%';
      }).attr('stop-color', function colorAccessor(d) {
        return d.color;
      });

      // TODO: there's no remove handler function now.
      // remove non-exist stops
      this.gradient.exit().remove();

      // refresh handlers
      this.handlers = this.svg.selectAll('.gc-handler').data(this.state.stops);

      // enter new handlers
      var self = this;
      var dragCallback = function dragCallback(d) {
        var newX = _d2.default.event.x;
        if (newX >= 0 && newX <= self.state.rootWidth) {
          self.dragHandler.call(this, d, newX);
        }
      };
      var drag = _d2.default.behavior.drag().origin(Object).on('drag', dragCallback).on('dragend', this.dragHandlerEnd.bind(this));
      this.handlers.enter().append('rect').attr('class', 'gc-handler').attr('x', (function xPos(d) {
        return d.x - HandlerWidth / 2;
      }).bind(this)).attr('y', '0').attr('width', '4').attr('height', this.state.rootHeight).call(drag);

      // update existing handlers
      this.handlers.attr('x', (function xPos(d) {
        return d.x - HandlerWidth / 2;
      }).bind(this));

      // remove non-exist handlers
      this.handlers.exit().remove();

      // refresh the color pickers
      this.state.stops.forEach(function iterator(s) {
        _d2.default.select('#gc-cp' + s.idx).style('left', s.x - ColorPickerWidth / 2 + 'px').style('top', Height + 'px');
      });

      // refresh color scale
      var stops = this.state.stops.map(function iterator(s) {
        return {
          offset: s.offset,
          color: s.color
        };
      }).sort(CompareOffset);
      var offsets = _lodash2.default.map(stops, 'offset');
      var colors = _lodash2.default.map(stops, 'color');
      this.colorScale = _d2.default.scale.linear().domain(offsets).range(colors);
    }
  }, {
    key: 'render',
    value: function render() {
      this.refreshCanvas();

      var colorChangeCallback = (function colorChangeCallback(color, idx) {
        var newStops = _lodash2.default.cloneDeep(this.state.stops);
        var currentHandler = _lodash2.default.find(newStops, { 'idx': idx });
        currentHandler.color = color;
        this.setState({ stops: newStops });
        this.props.onChange(this.colorScale);
      }).bind(this);
      var colorpickers = this.state.stops.map((function iterator(s) {
        var pickerId = 'gc-cp' + s.idx;
        var callback = function callback(c) {
          colorChangeCallback(c.color, s.idx);
        };
        var style = {
          left: s.x - ColorPickerWidth / 2 + 'px',
          top: Height + 'px'
        };
        return _react2.default.createElement(
          'div',
          { className: 'gc-colorpicker', id: pickerId, key: pickerId, style: style },
          _react2.default.createElement(_reactColorsPicker2.default, { animation: 'slide-up', color: s.color, onChange: callback })
        );
      }).bind(this));
      return _react2.default.createElement(
        'div',
        { className: 'gc-container', ref: 'root' },
        colorpickers,
        _react2.default.createElement('div', { id: 'gc-canvas' })
      );
    }
  }]);

  return ReactGradientColorPicker;
})(_react2.default.Component);

ReactGradientColorPicker.propTypes = {
  stops: _react2.default.PropTypes.arrayOf(_react2.default.PropTypes.object),
  onChange: _react2.default.PropTypes.func
};

module.exports = ReactGradientColorPicker;